﻿using System;
using System.IO;
using System.Linq;
using System.Text;

namespace GSharpDSL
{
    class CodeGenerator
    {
        private readonly AlgorithmInterface m_algInterface;
        private readonly string m_ioInterfaceName;

        public CodeGenerator(AlgorithmInterface algInterface)
        {
            m_algInterface = algInterface;
            m_ioInterfaceName = algInterface.M_Name;
        }

        public void GenerateAndEmitInterface(StreamWriter coreFileStreamWriter, StreamWriter algBodyFileStreamWriter = null)
        {
            if (m_algInterface == null) { Console.WriteLine("NULL algInterface"); return; }

            //--------ALG CORE FILE-------------
            StringBuilder fileHeaderStringBuilder = GenerateFileHeader(true);
            StringBuilder queryInfoStructureStringBuilder = GenerateQueryInfoStructure();
            StringBuilder algorithmStructureStringBuilder = GenerateAlgorithmStructure();
            StringBuilder fileFooterStringBuilder = GenerateFileFooter();
            coreFileStreamWriter.WriteLine(fileHeaderStringBuilder.ToString());
            coreFileStreamWriter.WriteLine(queryInfoStructureStringBuilder.ToString());
            coreFileStreamWriter.WriteLine(algorithmStructureStringBuilder.ToString());
            coreFileStreamWriter.WriteLine(fileFooterStringBuilder.ToString());
            //--------ALG BODY FILE---------
            if (algBodyFileStreamWriter != null)
            {
                StringBuilder fileHeaderStringBuilder2 = GenerateFileHeader();
                StringBuilder algorithmStructureStringBuilder2 = GenerateSecondFileAlgorithmStructure();
                algBodyFileStreamWriter.WriteLine(fileHeaderStringBuilder2.ToString());
                algBodyFileStreamWriter.WriteLine(algorithmStructureStringBuilder2.ToString());
                algBodyFileStreamWriter.WriteLine(fileFooterStringBuilder.ToString());
            }

        }

        private StringBuilder GenerateFileHeader(bool headerComment = false)
        {
            GenericStructure headerStructure = new GenericStructure(0);

            if(headerComment)
                headerStructure.AddBlock(GenerateHeaderCommentComboBlock());

            headerStructure.AddBlock(GenerateNamespaceImportsComboBlock());
            headerStructure.AddBlock(GenerateNamespaceComboBlock());
            return headerStructure.AssembleCodeContainer();
        }

        private ComboBlock GenerateHeaderCommentComboBlock()
        {
            ComboBlock cb = new ComboBlock(0);

            cb.AddCode("/*~!DO NOT EDIT!~\n" +
                       "* This file was automatically generated by GSharpDSL.\n" +
                       "* No changes will be saved on next compilation.\n" +
                       "* @Zestas Orestis.\n*/");
            cb.AddNewLine(2);

            return cb;
        }

        private ComboBlock GenerateNamespaceImportsComboBlock()
        {
            ComboBlock cb = new ComboBlock(0);

            foreach (var import in m_algInterface.M_NamespaceImports)
            {
                cb.AddCode("using " + import + ";");
                cb.AddNewLine();
            }

            cb.AddNewLine();
            return cb;
        }

        private ComboBlock GenerateNamespaceComboBlock()
        {
            ComboBlock cb = new ComboBlock(0);
            cb.AddCode("namespace " + m_algInterface.M_Namespace + " {");
            cb.AddNewLine();
            return cb;
        }

        private StringBuilder GenerateQueryInfoStructure()
        {
            GenericStructure mainStructure = new GenericStructure(1);

            //----------HEADER----------------------
            mainStructure.AddBlock(GenerateStructureHeaderComboBlock());
            mainStructure.EnterScope();
            //------NODE ACCESSORS & MODIFIERS------
            if (m_algInterface.M_NodeData?.M_NodeInfoMembers != null
                && m_algInterface.M_NodeData.M_NodeInfoMembers.M_Members.Any())
            {
                mainStructure.AddBlock(GenerateNodeMembersAccessorsComboBlock());
                mainStructure.AddBlock(GenerateNodeMembersModifiersComboBlock());
            }

            if (m_algInterface.M_NodeData?.M_GetterName != null && !m_algInterface.M_NodeData.M_GetterName.Equals(""))
            {
                mainStructure.AddBlock(GenerateNodeAccessorComboBlock());
            }

            if (m_algInterface.M_NodeData?.M_SetterName != null && !m_algInterface.M_NodeData.M_SetterName.Equals(""))
            {
                mainStructure.AddBlock(GenerateNodeModifierComboBlock());
            }
            //------EDGE ACCESSORS & MODIFIERS------
            if (m_algInterface.M_EdgeData?.M_EdgeInfoMembers != null
                && m_algInterface.M_EdgeData.M_EdgeInfoMembers.M_Members.Any())
            {
                mainStructure.AddBlock(GenerateEdgeMembersAccessorsComboBlock());
                mainStructure.AddBlock(GenerateEdgeMembersModifiersComboBlock());
            }

            if (m_algInterface.M_EdgeData?.M_GetterName != null && !m_algInterface.M_EdgeData.M_GetterName.Equals(""))
            {
                mainStructure.AddBlock(GenerateEdgeAccessorComboBlock());
            }

            if (m_algInterface.M_EdgeData?.M_SetterName != null && !m_algInterface.M_EdgeData.M_SetterName.Equals(""))
            {
                mainStructure.AddBlock(GenerateEdgeModifierComboBlock());
            }
            //------GRAPH ACCESSORS-----------------
            if (m_algInterface.M_GraphData?.M_GraphInfoMembers != null
                && m_algInterface.M_GraphData.M_GraphInfoMembers.M_Members.Any())
            {
                mainStructure.AddBlock(GenerateGraphMembersAccessorsComboBlock());
                mainStructure.AddBlock(GenerateGraphMembersModifiersComboBlock());
            }

            if (m_algInterface.M_GraphData?.M_GetterName != null && !m_algInterface.M_GraphData.M_GetterName.Equals(""))
            {
                mainStructure.AddBlock(GenerateGraphAccessorComboBlock());
            }

            if (m_algInterface.M_GraphData?.M_SetterName != null && !m_algInterface.M_GraphData.M_SetterName.Equals(""))
            {
                mainStructure.AddBlock(GenerateGraphModifierComboBlock());
            }
            //----------FOOTER-----------------------
            mainStructure.LeaveScope();
            mainStructure.AddCode("}");


            return mainStructure.AssembleCodeContainer();
        }

        private StringBuilder GenerateAlgorithmStructure()
        {
            GenericStructure mainStructure = new GenericStructure(1);

            //----------HEADER----------------------
            mainStructure.AddBlock(GenerateAlgorithmHeaderComboBlock());
            mainStructure.EnterScope();
            //----------CONSTRUCTOR------------------
            mainStructure.AddBlock(GenerateAlgorithmConstructorComboBlock());
            //------NODE ACCESSORS & MODIFIERS------
            if (m_algInterface.M_NodeData?.M_NodeInfoMembers != null
                && m_algInterface.M_NodeData.M_NodeInfoMembers.M_Members.Any())
            {
                mainStructure.AddBlock(GenerateAlgorithmNodeMembersAccessorsComboBlock());
                mainStructure.AddBlock(GenerateAlgorithmNodeMembersModifiersComboBlock());
            }

            if (m_algInterface.M_NodeData?.M_GetterName != null && !m_algInterface.M_NodeData.M_GetterName.Equals(""))
            {
                mainStructure.AddBlock(GenerateAlgorithmNodeAccessorComboBlock());
            }

            if (m_algInterface.M_NodeData?.M_SetterName != null && !m_algInterface.M_NodeData.M_SetterName.Equals(""))
            {
                mainStructure.AddBlock(GenerateAlgorithmNodeModifierComboBlock());
            }
            //------EDGE ACCESSORS & MODIFIERS------
            if (m_algInterface.M_EdgeData?.M_EdgeInfoMembers != null
                && m_algInterface.M_EdgeData.M_EdgeInfoMembers.M_Members.Any())
            {
                mainStructure.AddBlock(GenerateAlgorithmEdgeMembersAccessorsComboBlock());
                mainStructure.AddBlock(GenerateAlgorithmEdgeMembersModifiersComboBlock());
            }

            if (m_algInterface.M_EdgeData?.M_GetterName != null && !m_algInterface.M_EdgeData.M_GetterName.Equals(""))
            {
                mainStructure.AddBlock(GenerateAlgorithmEdgeAccessorComboBlock());
            }

            if (m_algInterface.M_EdgeData?.M_SetterName != null && !m_algInterface.M_EdgeData.M_SetterName.Equals(""))
            {
                mainStructure.AddBlock(GenerateAlgorithmEdgeModifierComboBlock());
            }
            //------GRAPH ACCESSORS-----------------
            if (m_algInterface.M_GraphData?.M_GraphInfoMembers != null
                && m_algInterface.M_GraphData.M_GraphInfoMembers.M_Members.Any())
            {
                mainStructure.AddBlock(GenerateAlgorithmGraphMembersAccessorsComboBlock());
                mainStructure.AddBlock(GenerateAlgorithmGraphMembersModifiersComboBlock());
            }

            if (m_algInterface.M_GraphData?.M_GetterName != null && !m_algInterface.M_GraphData.M_GetterName.Equals(""))
            {
                mainStructure.AddBlock(GenerateAlgorithmGraphAccessorComboBlock());
            }

            if (m_algInterface.M_GraphData?.M_SetterName != null && !m_algInterface.M_GraphData.M_SetterName.Equals(""))
            {
                mainStructure.AddBlock(GenerateAlgorithmGraphModifierComboBlock());
            }
            //----------ALGORITHM IO METHODS---------
            if (m_algInterface.M_Outputs.Count != 0)
                mainStructure.AddBlock(GenerateAlgorithmStoreOutputMethodComboBlock());
            if (m_algInterface.M_Inputs.Count != 0)
                mainStructure.AddBlock(GenerateAlgorithmInputsInitializationsMethodComboBlock());
            //----------FOOTER-----------------------
            mainStructure.LeaveScope();
            mainStructure.AddBlock(GenerateAlgorithmFooterComboBlock());

            return mainStructure.AssembleCode();
        }

        private StringBuilder GenerateSecondFileAlgorithmStructure()
        {
            GenericStructure mainStructure = new GenericStructure(1);
                
            mainStructure.AddBlock(GenerateSecondFileAlgorithmDeclarationComboBlock());
            mainStructure.EnterScope();
            mainStructure.AddBlock(GenerateSecondFileAlgorithmInitComboBlock());
            mainStructure.AddBlock(GenerateSecondFileAlgorithmRunComboBlock());
            mainStructure.LeaveScope();
            mainStructure.AddCode("}");

            return mainStructure.AssembleCodeContainer();
        }

        private StringBuilder GenerateFileFooter()
        {
            ComboBlock cb = new ComboBlock(1);
            cb.LeaveScope();
            cb.AddCode("}");
            return cb.AssembleCode();
        }

        private ComboBlock GenerateStructureHeaderComboBlock()
        {
            ComboBlock cb = new ComboBlock(0);

            cb.AddCode("public class ");
            cb.AddCode(m_ioInterfaceName + "QueryInfo : CGraphQueryInfo<", true);
            //------------------------------------------------------
            if (m_algInterface.M_NodeData == null)
                cb.AddCode("object,", true);
            else
                cb.AddCode(m_algInterface.M_NodeData.M_NodeInfoType.CSharpName() + ",", true);
            //------------------------------------------------------
            if (m_algInterface.M_EdgeData == null)
                cb.AddCode("object,", true);
            else
                cb.AddCode(m_algInterface.M_EdgeData.M_EdgeInfoType.CSharpName() + ",", true);
            //------------------------------------------------------
            if (m_algInterface.M_GraphData == null)
                cb.AddCode("object> {", true);
            else
                cb.AddCode(m_algInterface.M_GraphData.M_GraphInfoType.CSharpName() + "> {", true);
            //------------------------------------------------------

            cb.EnterScope();
            cb.AddCode("//CONSTRUCTOR");
            cb.AddNewLine();
            cb.AddCode("public " + m_ioInterfaceName + "QueryInfo(CGraph graph, object key) : base(graph,key) { }");
            cb.LeaveScope();

            return cb;
        }

        private ComboBlock GenerateNodeMembersAccessorsComboBlock()
        {
            ComboBlock cb = new ComboBlock(0);
            cb.AddCode("//NODE MEMBERS ACCESSORS");
            cb.AddNewLine();

            foreach (var member in m_algInterface.M_NodeData.M_NodeInfoMembers.M_Members)
            {
                cb.AddCode("public " + member.M_MemberInfoType.CSharpName() + " ");
                cb.AddCode(member.M_Name + "(CGraphNode node) {", true);
                cb.EnterScope();
                cb.AddCode("return Info(node)." + member.M_MemberPath + ";");
                cb.LeaveScope();
                cb.AddCode("}");
                cb.AddNewLine();
            }

            return cb;
        }

        private ComboBlock GenerateNodeAccessorComboBlock()
        {
            ComboBlock cb = new ComboBlock(0);
            cb.AddCode("//NODE ACCESSOR");
            cb.AddNewLine();

            cb.AddCode("public " + m_algInterface.M_NodeData.M_NodeInfoType.CSharpName() + " ");
            cb.AddCode(m_algInterface.M_NodeData.M_GetterName + "(CGraphNode node) {",true);
            cb.EnterScope();
            cb.AddCode("return Info(node);");
            cb.LeaveScope();
            cb.AddCode("}");
            cb.AddNewLine();

            return cb;
        }

        private ComboBlock GenerateEdgeMembersAccessorsComboBlock()
        {
            ComboBlock cb = new ComboBlock(0);
            cb.AddCode("//EDGE MEMBERS ACCESSORS");
            cb.AddNewLine();

            foreach (var member in m_algInterface.M_EdgeData.M_EdgeInfoMembers.M_Members)
            {
                cb.AddCode("public " + member.M_MemberInfoType.CSharpName() + " ");
                cb.AddCode(member.M_Name + "(CGraphEdge edge) {", true);
                cb.EnterScope();
                cb.AddCode("return Info(edge)." + member.M_MemberPath + ";");
                cb.LeaveScope();
                cb.AddCode("}");
                cb.AddNewLine();
            }

            return cb;
        }

        private ComboBlock GenerateEdgeAccessorComboBlock()
        {
            ComboBlock cb = new ComboBlock(0);
            cb.AddCode("//EDGE ACCESSOR");
            cb.AddNewLine();

            cb.AddCode("public " + m_algInterface.M_EdgeData.M_EdgeInfoType.CSharpName() + " ");
            cb.AddCode(m_algInterface.M_EdgeData.M_GetterName + "(CGraphEdge edge) {", true);
            cb.EnterScope();
            cb.AddCode("return Info(edge);");
            cb.LeaveScope();
            cb.AddCode("}");
            cb.AddNewLine();

            return cb;
        }

        private ComboBlock GenerateGraphMembersAccessorsComboBlock()
        {
            ComboBlock cb = new ComboBlock(0);
            cb.AddCode("//GRAPH MEMBER ACCESSORS");
            cb.AddNewLine();

            foreach (var member in m_algInterface.M_GraphData.M_GraphInfoMembers.M_Members)
            {
                cb.AddCode("public " + member.M_MemberInfoType.CSharpName() + " ");
                cb.AddCode(member.M_Name + "() {", true);
                cb.EnterScope();
                cb.AddCode("return Info()." + member.M_MemberPath + ";");
                cb.LeaveScope();
                cb.AddCode("}");
                cb.AddNewLine();
            }

            return cb;
        }

        private ComboBlock GenerateGraphAccessorComboBlock()
        {
            ComboBlock cb = new ComboBlock(0);
            cb.AddCode("//GRAPH ACCESSOR");
            cb.AddNewLine();

            cb.AddCode("public " + m_algInterface.M_GraphData.M_GraphInfoType.CSharpName() + " ");
            cb.AddCode(m_algInterface.M_GraphData.M_GetterName + "() {", true);
            cb.EnterScope();
            cb.AddCode("return Info();");
            cb.LeaveScope();
            cb.AddCode("}");
            cb.AddNewLine();

            return cb;
        }

        private ComboBlock GenerateNodeMembersModifiersComboBlock()
        {
            ComboBlock cb = new ComboBlock(0);
            cb.AddCode("//NODE MEMBERS MODIFIERS");
            cb.AddNewLine();

            foreach (var member in m_algInterface.M_NodeData.M_NodeInfoMembers.M_Members)
            {
                cb.AddCode("public void Set" + member.M_Name);
                cb.AddCode("(CGraphNode node, " + member.M_MemberInfoType.CSharpName() + " " + member.M_Name, true);
                cb.AddCode(") {", true);
                cb.EnterScope();
                cb.AddCode("Info(node)." + member.M_MemberPath);
                cb.AddCode(" = " + member.M_Name + ";", true);
                cb.LeaveScope();
                cb.AddCode("}");
                cb.AddNewLine();
            }

            return cb;
        }

        private ComboBlock GenerateNodeModifierComboBlock()
        {
            ComboBlock cb = new ComboBlock(0);
            cb.AddCode("//NODE MODIFIER");
            cb.AddNewLine();

            cb.AddCode("public void " + m_algInterface.M_NodeData.M_SetterName + "(CGraphNode node, ");
            cb.AddCode(m_algInterface.M_NodeData.M_NodeInfoType.CSharpName() + " info) {" , true);
            cb.EnterScope();
            cb.AddCode("CreateInfo(node, info);");
            cb.LeaveScope();
            cb.AddCode("}");
            cb.AddNewLine();

            return cb;
        }

        private ComboBlock GenerateEdgeMembersModifiersComboBlock()
        {
            ComboBlock cb = new ComboBlock(0);
            cb.AddCode("//EDGE MEMBERS MODIFIERS");
            cb.AddNewLine();

            foreach (var member in m_algInterface.M_EdgeData.M_EdgeInfoMembers.M_Members)
            {
                cb.AddCode("public void Set" + member.M_Name);
                cb.AddCode("(CGraphEdge edge, " + member.M_MemberInfoType.CSharpName() + " " + member.M_Name, true);
                cb.AddCode(") {", true);
                cb.EnterScope();
                cb.AddCode("Info(edge)." + member.M_MemberPath);
                cb.AddCode(" = " + member.M_Name + ";", true);
                cb.LeaveScope();
                cb.AddCode("}");
                cb.AddNewLine();
            }

            return cb;
        }

        private ComboBlock GenerateEdgeModifierComboBlock()
        {
            ComboBlock cb = new ComboBlock(0);
            cb.AddCode("//EDGE MODIFIER");
            cb.AddNewLine();

            cb.AddCode("public void " + m_algInterface.M_EdgeData.M_SetterName + "(CGraphEdge edge, ");
            cb.AddCode(m_algInterface.M_EdgeData.M_EdgeInfoType.CSharpName() + " info) {", true);
            cb.EnterScope();
            cb.AddCode("CreateInfo(edge, info);");
            cb.LeaveScope();
            cb.AddCode("}");
            cb.AddNewLine();

            return cb;
        }

        private ComboBlock GenerateGraphMembersModifiersComboBlock()
        {
            ComboBlock cb = new ComboBlock(0);
            cb.AddCode("//GRAPH MEMBERS MODIFIERS");
            cb.AddNewLine();

            foreach (var member in m_algInterface.M_GraphData.M_GraphInfoMembers.M_Members)
            {
                cb.AddCode("public void Set" + member.M_Name);
                cb.AddCode("(" + member.M_MemberInfoType.CSharpName() + " " + member.M_Name, true);
                cb.AddCode(") {", true);
                cb.EnterScope();
                cb.AddCode("Info()." + member.M_MemberPath);
                cb.AddCode(" = " + member.M_Name + ";", true);
                cb.LeaveScope();
                cb.AddCode("}");
                cb.AddNewLine();
            }

            return cb;
        }

        private ComboBlock GenerateGraphModifierComboBlock()
        {
            ComboBlock cb = new ComboBlock(0);
            cb.AddCode("//GRAPH MODIFIER");
            cb.AddNewLine();

            cb.AddCode("public void " + m_algInterface.M_GraphData.M_SetterName);
            cb.AddCode("(" + m_algInterface.M_GraphData.M_GraphInfoType.CSharpName() + " info) {", true);
            cb.EnterScope();
            cb.AddCode("CreateInfo(info);");
            cb.LeaveScope();
            cb.AddCode("}");
            cb.AddNewLine();

            return cb;
        }

        private ComboBlock GenerateAlgorithmHeaderComboBlock()
        {
            ComboBlock cb = new ComboBlock(0);
            cb.AddCode("//CGraphAlgorithm");
            cb.AddNewLine();

            cb.AddCode("public partial class " + m_ioInterfaceName);
            cb.AddCode(" : CGraphAlgorithm<int> {", true);
            cb.EnterScope();
            cb.AddCode("private " + m_ioInterfaceName + "QueryInfo ");
            cb.AddCode("m_output" + m_ioInterfaceName + "QueryInfo;", true);
            cb.AddNewLine();
            cb.AddBlock(GenerateAlgorithmInputsDeclarationsComboBlock());
            cb.AddBlock(GenerateAlgorithmOutputKeysDeclarationsComboBlock());

            return cb;
        }

        private ComboBlock GenerateAlgorithmConstructorComboBlock()
        {
            ComboBlock cb = new ComboBlock(0);
            cb.AddCode("//CGraphAlgorithm CONSTRUCTOR");
            cb.AddNewLine();

            cb.AddCode("public " + m_ioInterfaceName);
            cb.AddCode("(CGraph graph, object graphKEY) {", true);
            cb.EnterScope();
            cb.AddCode("m_output" + m_ioInterfaceName + "QueryInfo = new " + m_ioInterfaceName + "QueryInfo(graph, graphKEY);");

            cb.LeaveScope();
            cb.AddCode("}");
            cb.LeaveScope();

            return cb;
        }

        private ComboBlock GenerateAlgorithmNodeMembersAccessorsComboBlock()
        {
            ComboBlock cb = new ComboBlock(0);
            cb.AddCode("//CGraphAlgorithm NODE MEMBERS ACCESSORS");
            cb.AddNewLine();

            foreach (var member in m_algInterface.M_NodeData.M_NodeInfoMembers.M_Members)
            {
                cb.AddCode("protected " + member.M_MemberInfoType.CSharpName() + " ");
                cb.AddCode(member.M_Name + "(CGraphNode node) {", true);
                cb.EnterScope();
                cb.AddCode("return m_output" + m_ioInterfaceName + "QueryInfo." + member.M_Name + "(node);");
                cb.LeaveScope();
                cb.AddCode("}");
                cb.AddNewLine();
            }

            return cb;
        }

        private ComboBlock GenerateAlgorithmNodeAccessorComboBlock()
        {
            ComboBlock cb = new ComboBlock(0);
            cb.AddCode("//CGraphAlgorithm NODE ACCESSOR");
            cb.AddNewLine();

            cb.AddCode("protected " + m_algInterface.M_NodeData.M_NodeInfoType.CSharpName() + " ");
            cb.AddCode(m_algInterface.M_NodeData.M_GetterName + "(CGraphNode node) {", true);
            cb.EnterScope();
            cb.AddCode("return m_output" + m_ioInterfaceName + "QueryInfo." + m_algInterface.M_NodeData.M_GetterName + "(node);");
            cb.LeaveScope();
            cb.AddCode("}");
            cb.AddNewLine();

            return cb;
        }

        private ComboBlock GenerateAlgorithmEdgeMembersAccessorsComboBlock()
        {
            ComboBlock cb = new ComboBlock(0);
            cb.AddCode("//CGraphAlgorithm EDGE MEMBERS ACCESSORS");
            cb.AddNewLine();

            foreach (var member in m_algInterface.M_EdgeData.M_EdgeInfoMembers.M_Members)
            {
                cb.AddCode("protected " + member.M_MemberInfoType.CSharpName() + " ");
                cb.AddCode(member.M_Name + "(CGraphEdge edge) {", true);
                cb.EnterScope();
                cb.AddCode("return m_output" + m_ioInterfaceName + "QueryInfo." + member.M_Name + "(edge);");
                cb.LeaveScope();
                cb.AddCode("}");
                cb.AddNewLine();
            }

            return cb;
        }

        private ComboBlock GenerateAlgorithmEdgeAccessorComboBlock()
        {
            ComboBlock cb = new ComboBlock(0);
            cb.AddCode("//CGraphAlgorithm EDGE ACCESSOR");
            cb.AddNewLine();

            cb.AddCode("protected " + m_algInterface.M_EdgeData.M_EdgeInfoType.CSharpName() + " ");
            cb.AddCode(m_algInterface.M_EdgeData.M_GetterName + "(CGraphEdge edge) {", true);
            cb.EnterScope();
            cb.AddCode("return m_output" + m_ioInterfaceName + "QueryInfo." + m_algInterface.M_EdgeData.M_GetterName + "(edge);");
            cb.LeaveScope();
            cb.AddCode("}");
            cb.AddNewLine();

            return cb;
        }

        private ComboBlock GenerateAlgorithmGraphMembersAccessorsComboBlock()
        {
            ComboBlock cb = new ComboBlock(0);
            cb.AddCode("//CGraphAlgorithm GRAPH MEMBERS ACCESSORS");
            cb.AddNewLine();

            foreach (var member in m_algInterface.M_GraphData.M_GraphInfoMembers.M_Members)
            {
                cb.AddCode("public " + member.M_MemberInfoType.CSharpName() + " ");
                cb.AddCode(member.M_Name + "() {", true);
                cb.EnterScope();
                cb.AddCode("return m_output" + m_ioInterfaceName + "QueryInfo." + member.M_Name + "();");
                cb.LeaveScope();
                cb.AddCode("}");
                cb.AddNewLine();
            }

            return cb;
        }

        private ComboBlock GenerateAlgorithmGraphAccessorComboBlock()
        {
            ComboBlock cb = new ComboBlock(0);
            cb.AddCode("//CGraphAlgorithm GRAPH ACCESSOR");
            cb.AddNewLine();

            cb.AddCode("protected " + m_algInterface.M_GraphData.M_GraphInfoType.CSharpName() + " ");
            cb.AddCode(m_algInterface.M_GraphData.M_GetterName + "() {", true);
            cb.EnterScope();
            cb.AddCode("return m_output" + m_ioInterfaceName + "QueryInfo." + m_algInterface.M_GraphData.M_GetterName + "();");
            cb.LeaveScope();
            cb.AddCode("}");
            cb.AddNewLine();

            return cb;
        }

        private ComboBlock GenerateAlgorithmNodeMembersModifiersComboBlock()
        {
            ComboBlock cb = new ComboBlock(0);
            cb.AddCode("//CGraphAlgorithm NODE MEMBERS MODIFIERS");
            cb.AddNewLine();

            foreach (var member in m_algInterface.M_NodeData.M_NodeInfoMembers.M_Members)
            {
                cb.AddCode("protected void Set" + member.M_Name);
                cb.AddCode("(CGraphNode node, " + member.M_MemberInfoType.CSharpName() + " " + member.M_Name, true);
                cb.AddCode(") {", true);
                cb.EnterScope();
                cb.AddCode("m_output" + m_ioInterfaceName + "QueryInfo.Set" + member.M_Name +
                           "(node, " + member.M_Name + ");");
                cb.LeaveScope();
                cb.AddCode("}");
                cb.AddNewLine();
            }

            return cb;
        }

        private ComboBlock GenerateAlgorithmNodeModifierComboBlock()
        {
            ComboBlock cb = new ComboBlock(0);
            cb.AddCode("//CGraphAlgorithm NODE MODIFIER");
            cb.AddNewLine();

            cb.AddCode("protected void " + m_algInterface.M_NodeData.M_SetterName + "(CGraphNode node, ");
            cb.AddCode(m_algInterface.M_NodeData.M_NodeInfoType.CSharpName() + " info) {", true);
            cb.EnterScope();
            cb.AddCode("m_output" + m_ioInterfaceName + "QueryInfo." + m_algInterface.M_NodeData.M_SetterName + "(node, info);");
            cb.LeaveScope();
            cb.AddCode("}");
            cb.AddNewLine();

            return cb;
        }

        private ComboBlock GenerateAlgorithmEdgeMembersModifiersComboBlock()
        {
            ComboBlock cb = new ComboBlock(0);
            cb.AddCode("//CGraphAlgorithm EDGE MEMBERS MODIFIERS");
            cb.AddNewLine();

            foreach (var member in m_algInterface.M_EdgeData.M_EdgeInfoMembers.M_Members)
            {
                cb.AddCode("protected void Set" + member.M_Name);
                cb.AddCode("(CGraphNode node, " + member.M_MemberInfoType.CSharpName() + " " + member.M_Name, true);
                cb.AddCode(") {", true);
                cb.EnterScope();
                cb.AddCode("m_output" + m_ioInterfaceName + "QueryInfo.Set" + member.M_Name +
                           "(node, " + member.M_Name + ");");
                cb.LeaveScope();
                cb.AddCode("}");
                cb.AddNewLine();
            }

            return cb;
        }

        private ComboBlock GenerateAlgorithmEdgeModifierComboBlock()
        {
            ComboBlock cb = new ComboBlock(0);
            cb.AddCode("//CGraphAlgorithm EDGE MODIFIER");
            cb.AddNewLine();

            cb.AddCode("protected void " + m_algInterface.M_EdgeData.M_SetterName + "(CGraphEdge edge, ");
            cb.AddCode(m_algInterface.M_EdgeData.M_EdgeInfoType.CSharpName() + " info) {", true);
            cb.EnterScope();
            cb.AddCode("m_output" + m_ioInterfaceName + "QueryInfo." + m_algInterface.M_EdgeData.M_SetterName + "(edge, info);");
            cb.LeaveScope();
            cb.AddCode("}");
            cb.AddNewLine();

            return cb;
        }

        private ComboBlock GenerateAlgorithmGraphMembersModifiersComboBlock()
        {
            ComboBlock cb = new ComboBlock(0);
            cb.AddCode("//CGraphAlgorithm GRAPH MEMBERS MODIFIERS");
            cb.AddNewLine();

            foreach (var member in m_algInterface.M_GraphData.M_GraphInfoMembers.M_Members)
            {
                cb.AddCode("protected void Set" + member.M_Name + "( ");
                cb.AddCode(member.M_MemberInfoType.CSharpName() + " info) {", true);
                cb.EnterScope();
                cb.AddCode("m_output" + m_ioInterfaceName + "QueryInfo.Set" + member.M_Name + "(info);");
                cb.LeaveScope();
                cb.AddCode("}");
                cb.AddNewLine();
            }

            return cb;
        }

        private ComboBlock GenerateAlgorithmGraphModifierComboBlock()
        {
            ComboBlock cb = new ComboBlock(0);
            cb.AddCode("//CGraphAlgorithm GRAPH MODIFIER");
            cb.AddNewLine();

            cb.AddCode("protected void " + m_algInterface.M_GraphData.M_SetterName + "( ");
            cb.AddCode(m_algInterface.M_GraphData.M_GraphInfoType.CSharpName() + " info) {", true);
            cb.EnterScope();
            cb.AddCode("m_output" + m_ioInterfaceName + "QueryInfo." + m_algInterface.M_GraphData.M_SetterName + "(info);");
            cb.LeaveScope();
            cb.AddCode("}");
            cb.AddNewLine();

            return cb;
        }

        private ComboBlock GenerateAlgorithmFooterComboBlock()
        {
            ComboBlock cb = new ComboBlock(0);
            cb.AddCode("}");

            return cb;
        }

        private ComboBlock GenerateSecondFileAlgorithmDeclarationComboBlock()
        {
            ComboBlock cb = new ComboBlock(0);

            cb.AddCode("public partial class " + m_ioInterfaceName + " { ");
            cb.AddNewLine();

            return cb;
        }

        private ComboBlock GenerateSecondFileAlgorithmInitComboBlock()
        {
            ComboBlock cb = new ComboBlock(0);

            cb.AddCode("public override void Init() {");
            cb.EnterScope();
            cb.AddCode("/*TODO: Write Init function!*/");

            if (m_algInterface.M_Inputs.Count != 0)
            {
                cb.AddNewLine();
                cb.AddCode("InitializeInputs();");
            }

            cb.LeaveScope();
            cb.AddCode("}");
            cb.AddNewLine(2);

            return cb;
        }

        private ComboBlock GenerateSecondFileAlgorithmRunComboBlock()
        {
            ComboBlock cb = new ComboBlock(0);

            cb.AddCode("public override int Run() {");
            cb.EnterScope();
            cb.AddCode("Init();");
            cb.AddNewLine();

            if (m_algInterface.M_Outputs.Count != 0)
            {
                cb.AddCode("/*TODO: Write Run function!");
                cb.AddNewLine();
                cb.AddCode("* Don't forget to store your outputs to IOBank!*/");
                cb.AddNewLine();
                foreach (var output in m_algInterface.M_Outputs)
                {
                    cb.AddCode("StoreOutput(" + output.M_OutputName.ToUpper() + "_KEY" +",null);");
                    cb.AddNewLine();
                }
            }
            else cb.AddCode("/*TODO: Write Run function!*/");
 

            cb.AddNewLine();
            cb.AddCode("return 0;");
            cb.LeaveScope();
            cb.AddCode("}");
            cb.AddNewLine();

            return cb;
        }

        private ComboBlock GenerateAlgorithmInputsDeclarationsComboBlock()
        {
            ComboBlock cb = new ComboBlock(0);

            if (m_algInterface.M_Inputs.Count != 0)
            {
                foreach (var input in m_algInterface.M_Inputs)
                {
                    cb.AddCode("private " + input.M_InputType.CSharpName() + " " + input.M_InputName + ";");
                    cb.AddNewLine();
                }
            }

            return cb;
        }

        private ComboBlock GenerateAlgorithmInputsInitializationComboBlock()
        {
            ComboBlock cb = new ComboBlock(0);

            if (m_algInterface.M_Inputs.Count != 0)
            {
                foreach (var input in m_algInterface.M_Inputs)
                {
                    cb.AddCode(input.M_InputName + " = " + "(" + input.M_InputType.CSharpName());
                    cb.AddCode(")IOBank.GetItemFromBank(\"" + input.M_ConnectionFromKey + "\");",true);
                    cb.AddNewLine();
                }
            }

            return cb;
        }

        private ComboBlock GenerateAlgorithmOutputKeysDeclarationsComboBlock()
        {
            ComboBlock cb = new ComboBlock(0);

            if (m_algInterface.M_Outputs.Count != 0)
            {
                foreach (var output in m_algInterface.M_Outputs)
                {
                    cb.AddCode("private string " + output.M_OutputName.ToUpper() + "_KEY = \"" + output.M_ConnectionToKey + "\";");
                    cb.AddNewLine();
                }
            }

            return cb;
        }

        private ComboBlock GenerateAlgorithmInputsInitializationsMethodComboBlock()
        {
            ComboBlock cb = new ComboBlock(0);

            cb.AddNewLine();
            cb.AddCode("private void InitializeInputs() {");
            cb.EnterScope();
            cb.AddBlock(GenerateAlgorithmInputsInitializationComboBlock());
            cb.LeaveScope();
            cb.AddCode("}");

            return cb;
        }

        private ComboBlock GenerateAlgorithmStoreOutputMethodComboBlock()
        {
            ComboBlock cb = new ComboBlock(0);

            cb.AddNewLine();
            cb.AddCode("private void StoreOutput(string key, object value) {");
            cb.EnterScope();
            cb.AddCode("IOBank.SetValueForItemInBank(key,value);");
            cb.LeaveScope();
            cb.AddCode("}");

            return cb;
        }
    }
}
